#ifndef LHAPDFWRAP_H
#define LHAPDFWRAP_H

#include <string>
#include <vector>
#include "FortranWrappers.h"

// WARNING! This C++ interface is deprecated in favour of the 
// interface declared in LHAPDF/LHAPDF.h

// This class is a wrapper around the LHAPDF package for parton
// distribution functions of the proton.
//
// Originally by Stefan Gieseke.
// Adapted for LHAPDFv4 by Mike Whalley.
// Adapted for LHAPDFv5 by Craig Group/Mike Whalley.
// Fortran portability and interface improvements by Andy Buckley.


extern "C" {

  #define finitpdfset_ FC_FUNC(finitpdfset, FINITPDFSET)
  void finitpdfset_(char*, int len);
  #define finitpdfsetbyname_ FC_FUNC(finitpdfsetbyname, FINITPDFSETBYNAME)
  void finitpdfsetbyname_(char*, int len);
  #define finitpdf_ FC_FUNC(finitpdf, FINITPDF)
  void finitpdf_(int*);
  #define fevolvepdf_ FC_FUNC(fevolvepdf, FEVOLVEPDF)
  void fevolvepdf_(double*, double *, double*);
  #define fevolvepdfp_ FC_FUNC(fevolvepdfp, FEVOLVEPDFP)
  void fevolvepdfp_(double*, double *, double*, int*, double*);
  #define fevolvepdfa_ FC_FUNC(fevolvepdfa, FEVOLVEPDFA)
  void fevolvepdfa_(double*, double *, double *, double*);
  #define fevolvepdfphoton_ FC_FUNC(fevolvepdfphoton, FEVOLVEPDFPHOTON)
  void fevolvepdfphoton_(double*, double *, double*, double*);
  #define fnumberpdf_ FC_FUNC(fnumberpdf, FNUMBERPDF)
  void fnumberpdf_(int*);
  #define falphaspdf_ FC_FUNC(falphaspdf, FALPHASPDF)
  void falphaspdf_(double*, double *);
  #define fgetorderpdf_ FC_FUNC(fgetorderpdf, FGETORDERPDF)
  void fgetorderpdf_(int*);
  #define fgetorderas_ FC_FUNC(fgetorderas, FGETORDERAS)
  void fgetorderas_(int*);
  #define fgetdesc_ FC_FUNC(fgetdesc, FGETDESC)
  void fgetdesc_();
  #define fgetqmass_ FC_FUNC(fgetqmass, FGETQMASS)
  void fgetqmass_(int*, double*);
  #define fgetthreshold_ FC_FUNC(fgetthreshold, FGETTHRESHOLD)
  void fgetthreshold_(int*, double*);
  #define fgetnf_ FC_FUNC(fgetnf, FGETNF)
  void fgetnf_(int*);
  #define fgetlam4_ FC_FUNC(fgetlam4, FGETLAM4)
  void fgetlam4_(int*, double*);
  #define fgetlam5_ FC_FUNC(fgetlam5, FGETLAM5)
  void fgetlam5_(int*, double*);
  #define fgetxmin_ FC_FUNC(fgetxmin, FGETXMIN)
  void fgetxmin_(int*, double*);
  #define fgetxmax_ FC_FUNC(fgetxmax, FGETXMAX)
  void fgetxmax_(int*, double*);
  #define fgetq2min_ FC_FUNC(fgetq2min, FGETQ2MIN)
  void fgetq2min_(int*, double*);
  #define fgetq2max_ FC_FUNC(fgetq2max, FGETQ2MAX)
  void fgetq2max_(int*, double*);
  #define fgetminmax_ FC_FUNC(fgetminmax, FGETMINMAX)
  void fgetminmax_(int*, double*, double*, double*, double*);
  #define fextrapolate_ FC_FUNC(fextrapolate, FEXTRAPOLATE)
  void fextrapolate_();

  // v5 subroutines for multiple set initialization
  #define finitpdfsetm_ FC_FUNC(finitpdfsetm, FINITPDFSETM)
  void finitpdfsetm_(int*, char*, int len);
  #define finitpdfsetbynamem_ FC_FUNC(finitpdfsetbynamem, FINITPDFSETBYNAMEM)
  void finitpdfsetbynamem_(int*, char*, int len);
  #define finitpdfm_ FC_FUNC(finitpdfm, FINITPDFM)
  void finitpdfm_(int*, int*);
  #define fevolvepdfm_ FC_FUNC(fevolvepdfm, FEVOLVEPDFM)
  void fevolvepdfm_(int*, double*, double *, double*);
  #define fevolvepdfpm_ FC_FUNC(fevolvepdfpm, FEVOLVEPDFPM)
  void fevolvepdfpm_(int*, double*, double *, double*, int*, double*);
  #define fevolvepdfam_ FC_FUNC(fevolvepdfam, FEVOLVEPDFAM)
  void fevolvepdfam_(int*, double*, double *, double *, double*);
  #define fevolvepdfphotonm_ FC_FUNC(fevolvepdfphotonm, FEVOLVEPDFPHOTONM)
  void fevolvepdfphotonm_(int*, double*, double *, double*, double*);
  #define fnumberpdfm_ FC_FUNC(fnumberpdfm, FNUMBERPDFM)
  void fnumberpdfm_(int*, int*);
  #define falphaspdfm_ FC_FUNC(falphaspdfm, FALPHASPDFM)
  void falphaspdfm_(int*, double*, double *);
  #define fgetorderpdfm_ FC_FUNC(fgetorderpdfm, FGETORDERPDFM)
  void fgetorderpdfm_(int*, int*);
  #define fgetorderasm_ FC_FUNC(fgetorderasm, FGETORDERASM)
  void fgetorderasm_(int*, int*);
  #define fgetdescm_ FC_FUNC(fgetdescm, FGETDESCM)
  void fgetdescm_(int*);
  #define fgetqmassm_ FC_FUNC(fgetqmassm, FGETQMASSM)
  void fgetqmassm_(int*, int*, double*);
  #define fgetthresholdm_ FC_FUNC(fgetthresholdm, FGETTHRESHOLDM)
  void fgetthresholdm_(int*, int*, double*);
  #define fgetnfm_ FC_FUNC(fgetnfm, FGETNFM)
  void fgetnfm_(int*, int*);
  #define fgetlam4m_ FC_FUNC(fgetlam4m, FGETLAM4M)
  void fgetlam4m_(int*, int*, double*);
  #define fgetlam5m_ FC_FUNC(fgetlam5m, FGETLAM5M)
  void fgetlam5m_(int*, int*, double*);
  #define fgetxminm_ FC_FUNC(fgetxminm, FGETXMINM)
  void fgetxminm_(int*, int*, double*);
  #define fgetxmaxm_ FC_FUNC(fgetxmaxm, FGETXMAXM)
  void fgetxmaxm_(int*, int*, double*);
  #define fgetq2minm_ FC_FUNC(fgetq2minm, FGETQ2MINM)
  void fgetq2minm_(int*, int*, double*);
  #define fgetq2maxm_ FC_FUNC(fgetq2maxm, FGETQ2MAXM)
  void fgetq2maxm_(int*, int*, double*);
  #define fgetminmaxm_ FC_FUNC(fgetminmaxm, FGETMINMAXM)
  void fgetminmaxm_(int*, int*, double*, double*, double*, double*);
}



/////////////////////////////////////////////////////////////////


/// Wrapper class used to contain all the wrapper functions.
/// @deprecated 
/// The class-based C++ wrapper on LHAPDF will be retired in a forthcoming
/// release of LHAPDF in favour of the namespaced wrapper declared in @c
/// LHAPDF.h. Please convert client code which uses the class interface to use
/// the new interface instead.  Typically, this will just involve changing the
/// header include from @c "LHAPDF/LHAPDFWrap.h" to @c "LHAPDF/LHAPDFWrap.h",
/// changing any constructors to initialisation functions, and replacing @c
/// LHAPDFWrap objects with an @c LHAPDF namespace. For example,
/// @code
///  #include "LHAPDF/LHAPDFWrap.h"
///  LHAPDFWrap pdf = LHAPDFWrap("MRST2004qed.LHgrid", 0);
///  pdf.getDescription();
/// @endcode
/// would be replaced by
/// @code
///  #include "LHAPDF/LHAPDF.h"
///  LHAPDF::initPDFByName("MRST2004qed.LHgrid", 0);
///  LHAPDF::getDescription();
/// @endcode
class LHAPDFWrap {

public:
  /// Do-nothing constructor.
  LHAPDFWrap();
  
  /// Typical constructor with PDF set 'name' 
  /// 'name' is the name of the grid or data file of the desired set.  
  LHAPDFWrap(const std::string& name);

  /// Typical constructor with PDF set 'name' and subset 'memset' 
  /// 'name' is the name of the grid or data file of the desired set.  
  LHAPDFWrap(const std::string& name, int memset);

  /// Typical constructor (when multiple PDF sets need to be initialized) 
  /// with pdfset 'name' and subset 'memset'.
  /// 'name' is the name of the grid or data file of the desired set.  
  /// int nset specifies the reference number for the set to be initialized
  LHAPDFWrap(int nset, const std::string& name);

  /// Typical constructor (when multiple PDF sets need to be initialized) 
  /// with PDF set 'name' and subset 'memset'. 
  /// 'name' is the name of the grid or data file of the desired set.  
  /// int nset specifies the reference number for the set to be initialized
  LHAPDFWrap(int nset, const std::string& name, int memset);

  /// Returns a vector xf(x, Q) with index 0 < i < 12.
  /// 0..5 = tbar, ..., ubar, dbar; 
  /// 6 = g; 
  /// 7..12 = d, u, ..., t
  std::vector<double> xfx(double x, double Q);

  /// Returns xf(x, Q) for flavour fl - this time the flavour encoding
  /// is as in the LHAPDF manual...
  /// -6..-1 = tbar,...,ubar, dbar
  /// 1..6 = duscbt
  /// 0 = g
  double xfx(double x, double Q, int fl);

  std::vector<double> xfxp(double x, double Q, double P2, int ip);
  double xfxp(double x, double Q, double P2, int ip, int fl);

  std::vector<double> xfxa(double x, double Q, double a);
  double xfxa(double x, double Q, double a, int fl);

  std::vector<double> xfxphoton(double x, double Q);
  double xfxphoton(double x, double Q, int fl);

  /// The PDF set by name, see subdir 'PDFset' of LHAPDFv2 for choices
  void initPDFSet(const std::string& name);

  /// The PDF set by name, see subdir 'PDFset' of LHAPDFv2 for choices
  void initPDFSetByName(const std::string& name);

  /// The choice of PDF subset out of one distribution
  void initPDF(int memset);

  /// Prints a brief description of the current pdf set to stdout
  void getDescription();

  /// Number of subsets available in the current distribution.
  int numberPDF();

  /// \f$ \alpha_\mathrm{s} \f$ used by the current PDF.
  double alphasPDF(double Q);

  int getOrderPDF();

  /// Perturbative order of parton evolution and \f$ \alpha_\mathrm{s} \f$ respectively.
  int getOrderAlphaS();

  /// Quark mass used for flavour f.
  double getQMass(int f);

  /// Threshold for flavour f.
  double getThreshold(int f);

  /// Number of flavours used in the current PDF set.
  int getNf();

  /// Value of QCD lambda4 for member m 
  double getLam4(int m);

  /// Value of QCD lambda5 for member m 
  double getLam5(int m);

  double getXmin(int m);
  double getXmax(int m);
  double getQ2min(int m);
  double getQ2max(int m);

  inline void extrapolate(){ fextrapolate_();};

  // Additional functions for when more than 1 PDF set is being stored in memory

  // Returns a vector xf(x, Q) with index 0 < i < 12.
  // 0..5 = tbar, ..., ubar, dbar; 
  // 6 = g; 
  // 7..12 = d, u, ..., t
  std::vector<double> xfxM(int nset, double x, double Q);

  // Returns xf(x, Q) for flavour fl - this time the flavour encoding
  // is as in the LHAPDF manual...
  // -6..-1 = tbar,...,ubar, dbar
  // 1..6 = duscbt
  // 0 = g
  double xfxM(int nset, double x, double Q, int fl);

  std::vector<double> xfxpM(int nset, double x, double Q, double P2, int ip);
  double xfxpM(int nset, double x, double Q, double P2, int ip, int fl);

  std::vector<double> xfxaM(int nset, double x, double Q, double a);
  double xfxaM(int nset, double x, double Q, double a, int fl);

  std::vector<double> xfxphotonM(int nset, double x, double Q);
  double xfxphotonM(int nset, double x, double Q, int fl);

  /// The PDF set by name, see subdir 'PDFset' of LHAPDFv2 for choices
  void initPDFSetM(int nset, const std::string& name);

  /// The PDF set by name, see subdir 'PDFset' of LHAPDFv2 for choices
  void initPDFSetByNameM(int nset, const std::string& name);

  /// The choice of PDF subset out of one distribution
  void initPDFM(int nset, int memset);

  /// Prints a brief description of the current PDF set to stdout
  void getDescriptionM(int nset);

  /// Number of subsets available in the current distribution.
  int numberPDFM(int nset);

  /// \f$ \alpha_\mathrm{s} \f$ used by the current PDF.
  double alphasPDFM(int nset, double Q);

  int getOrderPDFM(int nset);

  /// Perturbative order of parton evolution and \f$ \alpha_\mathrm{s} \f$ respectively.
  int getOrderAlphaSM(int nset);

  /// Quark mass used for flavour f.
  double getQMassM(int nset, int f);

  /// Threshold for flavour f.
  double getThresholdM(int nset, int f);

  /// Number of flavours used in the current PDF set.
  int getNfM(int nset);

  /// Value of QCD lambda4 for member m 
  double getLam4M(int nset, int m);

  /// Value of QCD lambda5 for member m 
  double getLam5M(int nset, int m);

  double getXminM(int nset, int m);
  double getXmaxM(int nset, int m);
  double getQ2minM(int nset, int m);
  double getQ2maxM(int nset, int m);

};

#endif
