#ifndef LHAPDFfw_H
#define LHAPDFfw_H

// Forward declarations of signatures of Fortran
// intermediate wrapper functions.

#include "LHAPDF/FortranWrappers.h"

extern "C" {

  #define finitpdfset_ FC_FUNC(finitpdfset, FINITPDFSET)
  void finitpdfset_(char*, int len);
  #define finitpdfsetbyname_ FC_FUNC(finitpdfsetbyname, FINITPDFSETBYNAME)
  void finitpdfsetbyname_(char*, int len);
  #define finitpdf_ FC_FUNC(finitpdf, FINITPDF)
  void finitpdf_(int*);
  #define fevolvepdf_ FC_FUNC(fevolvepdf, FEVOLVEPDF)
  void fevolvepdf_(double*, double *, double*);
  #define fevolvepdfp_ FC_FUNC(fevolvepdfp, FEVOLVEPDFP)
  void fevolvepdfp_(double*, double *, double*, int*, double*);
  #define fevolvepdfa_ FC_FUNC(fevolvepdfa, FEVOLVEPDFA)
  void fevolvepdfa_(double*, double *, double *, double*);
  #define fevolvepdfphoton_ FC_FUNC(fevolvepdfphoton, FEVOLVEPDFPHOTON)
  void fevolvepdfphoton_(double*, double *, double*, double*);
  #define fnumberpdf_ FC_FUNC(fnumberpdf, FNUMBERPDF)
  void fnumberpdf_(int*);
  #define falphaspdf_ FC_FUNC(falphaspdf, FALPHASPDF)
  void falphaspdf_(double*, double *);
  #define fgetorderpdf_ FC_FUNC(fgetorderpdf, FGETORDERPDF)
  void fgetorderpdf_(int*);
  #define fgetorderas_ FC_FUNC(fgetorderas, FGETORDERAS)
  void fgetorderas_(int*);
  #define fgetdesc_ FC_FUNC(fgetdesc, FGETDESC)
  void fgetdesc_();
  #define fgetqmass_ FC_FUNC(fgetqmass, FGETQMASS)
  void fgetqmass_(int*, double*);
  #define fgetthreshold_ FC_FUNC(fgetthreshold, FGETTHRESHOLD)
  void fgetthreshold_(int*, double*);
  #define fgetnf_ FC_FUNC(fgetnf, FGETNF)
  void fgetnf_(int*);
  #define fgetlam4_ FC_FUNC(fgetlam4, FGETLAM4)
  void fgetlam4_(int*, double*);
  #define fgetlam5_ FC_FUNC(fgetlam5, FGETLAM5)
  void fgetlam5_(int*, double*);
  #define fgetxmin_ FC_FUNC(fgetxmin, FGETXMIN)
  void fgetxmin_(int*, double*);
  #define fgetxmax_ FC_FUNC(fgetxmax, FGETXMAX)
  void fgetxmax_(int*, double*);
  #define fgetq2min_ FC_FUNC(fgetq2min, FGETQ2MIN)
  void fgetq2min_(int*, double*);
  #define fgetq2max_ FC_FUNC(fgetq2max, FGETQ2MAX)
  void fgetq2max_(int*, double*);
  #define fgetminmax_ FC_FUNC(fgetminmax, FGETMINMAX)
  void fgetminmax_(int*, double*, double*, double*, double*);
  #define fextrapolate_ FC_FUNC(fextrapolate, FEXTRAPOLATE)
  void fextrapolate_();

  // v5 subroutines for multiple set initialization
  #define finitpdfsetm_ FC_FUNC(finitpdfsetm, FINITPDFSETM)
  void finitpdfsetm_(int*, char*, int len);
  #define finitpdfsetbynamem_ FC_FUNC(finitpdfsetbynamem, FINITPDFSETBYNAMEM)
  void finitpdfsetbynamem_(int*, char*, int len);
  #define finitpdfm_ FC_FUNC(finitpdfm, FINITPDFM)
  void finitpdfm_(int*, int*);
  #define fevolvepdfm_ FC_FUNC(fevolvepdfm, FEVOLVEPDFM)
  void fevolvepdfm_(int*, double*, double *, double*);
  #define fevolvepdfpm_ FC_FUNC(fevolvepdfpm, FEVOLVEPDFPM)
  void fevolvepdfpm_(int*, double*, double *, double*, int*, double*);
  #define fevolvepdfam_ FC_FUNC(fevolvepdfam, FEVOLVEPDFAM)
  void fevolvepdfam_(int*, double*, double *, double *, double*);
  #define fevolvepdfphotonm_ FC_FUNC(fevolvepdfphotonm, FEVOLVEPDFPHOTONM)
  void fevolvepdfphotonm_(int*, double*, double *, double*, double*);
  #define fnumberpdfm_ FC_FUNC(fnumberpdfm, FNUMBERPDFM)
  void fnumberpdfm_(int*, int*);
  #define falphaspdfm_ FC_FUNC(falphaspdfm, FALPHASPDFM)
  void falphaspdfm_(int*, double*, double *);
  #define fgetorderpdfm_ FC_FUNC(fgetorderpdfm, FGETORDERPDFM)
  void fgetorderpdfm_(int*, int*);
  #define fgetorderasm_ FC_FUNC(fgetorderasm, FGETORDERASM)
  void fgetorderasm_(int*, int*);
  #define fgetdescm_ FC_FUNC(fgetdescm, FGETDESCM)
  void fgetdescm_(int*);
  #define fgetqmassm_ FC_FUNC(fgetqmassm, FGETQMASSM)
  void fgetqmassm_(int*, int*, double*);
  #define fgetthresholdm_ FC_FUNC(fgetthresholdm, FGETTHRESHOLDM)
  void fgetthresholdm_(int*, int*, double*);
  #define fgetnfm_ FC_FUNC(fgetnfm, FGETNFM)
  void fgetnfm_(int*, int*);
  #define fgetlam4m_ FC_FUNC(fgetlam4m, FGETLAM4M)
  void fgetlam4m_(int*, int*, double*);
  #define fgetlam5m_ FC_FUNC(fgetlam5m, FGETLAM5M)
  void fgetlam5m_(int*, int*, double*);
  #define fgetxminm_ FC_FUNC(fgetxminm, FGETXMINM)
  void fgetxminm_(int*, int*, double*);
  #define fgetxmaxm_ FC_FUNC(fgetxmaxm, FGETXMAXM)
  void fgetxmaxm_(int*, int*, double*);
  #define fgetq2minm_ FC_FUNC(fgetq2minm, FGETQ2MINM)
  void fgetq2minm_(int*, int*, double*);
  #define fgetq2maxm_ FC_FUNC(fgetq2maxm, FGETQ2MAXM)
  void fgetq2maxm_(int*, int*, double*);
  #define fgetminmaxm_ FC_FUNC(fgetminmaxm, FGETMINMAXM)
  void fgetminmaxm_(int*, int*, double*, double*, double*, double*);
  #define fextrapolateon_ FC_FUNC(fextrapolateon, FEXTRAPOLATEON)
  void fextrapolateon_();
  #define fextrapolateoff_ FC_FUNC(fextrapolateoff, FEXTRAPOLATEOFF)	  
  void fextrapolateoff_();
  #define fsilent_ FC_FUNC(fsilent, FSILENT) 
  void fsilent_();
  #define flowkey_ FC_FUNC(flowkey, FLOWKEY)
  void flowkey_();
  #define fdefaultverb_ FC_FUNC(fdefaultverb, FDEFAULTVERB)
  void fdefaultverb_();
  #define fsetpdfpath_ FC_FUNC(fsetpdfpath, FSETPDFPATH)
  void fsetpdfpath_(char*, int len);

}

#endif
